import 'package:fluartx/fluartx.dart';
import 'package:test/test.dart';

void main() {
  group("test collections", () {
    test('[IterableX] test isNullOrEmpty', () {
      expect(null.isNullOrEmpty, true);
    });

    test('[IterableX] test elementAtOrNull', () {
      expect(<int>[1, 2, 3].elementAtOrNull(3), equals(null));
    });

    test('[ListX] test elementAtOrElse', () {
      expect(<int>[1, 2, 3].elementAtOrElse(3, (index) => index), equals(3));
    });

    test('[IterableX] test firstOrNull(bool predicate(T t))', () {
      expect(<int>[1, 2, 3].firstOrNull(Predicates.equalTo(2)), equals(2));
    });

    test('[IterableX] test all(bool predicate(T t))', () {
      expect(<int>[1, 2, 3].all(Predicates.instanceOf(int)), isTrue);
    });

    test('[IterableX] test groupBy<K>(K keySelector(T t))', () {
      expect(<int>[1, 2, 3, 4, 5].groupBy((ele) => ele % 2)[1].length, equals(3));
    });

    test('[IterableX] test groupBy2', () {
      expect(<int>[1, 2, 3, 4, 5].groupBy2((ele) => ele % 2,
          Transformers.forMap(<int, String>{
            1: "ele->1",
            2: "ele->2",
            3: "ele->3",
            4: "ele->4",
            5: "ele->5",
          }))[1][0], equals("ele->1"));
    });
  });
}
